UNIT ScrCopy;
INTERFACE
  USES Graph;

  PROCEDURE HardCopy(Inverse:Boolean);
IMPLEMENTATION

  PROCEDURE HardCopy(Inverse:Boolean);{nec p6}
  VAR j,top       :integer;
      PrintBuffer :LongInt;
      PrintByte   :Array [1..4] of Byte Absolute PrintBuffer;
      ViewPort    :ViewPortType;

    procedure Print(x:Byte);
    Inline(
           {POP  AX     }  $58/
           {XOR  AH,AH  }  $30/$E4/
           {XOR  DX,DX  }  $31/$D2/
           {INT  17H    }  $CD/$17);

    Procedure DoLine(Top:Integer);
    VAR i,z,breite:integer;

      function constructLongInt(j,i:integer):LongInt;
        Const Bits  : Array [0..23] of longint =
                      (8388608, 4194304, 2097152, 1048576,
                        524288,  262144,  131072,   65536,
                         32768,   16384,    8192,    4096,
                          2048,    1024,     512,     256,
                           128,      64,      32,      16,
                             8,       4,       2,       1);
        Var CByte:LongInt;
            k    :Byte;

        begin
              j     :=j SHL 3;
              CByte :=0;
              For  k:=0 to top do
                if getpixel( j+k ,i) <>0 then begin
                  CByte:=CByte or Bits[k*3];
                  CByte:=CByte or Bits[(k*3)+1];
                  CByte:=CByte or Bits[(k*3)+2];
                end;
              constructLongInt := CByte;
        end;{constructLongInt}
      begin {doline}
        breite := (getMaxY + 1)*2;
        Print(27);Print(ord('*')); print(33);
        Print(Lo(breite)); Print(Hi(breite));
        For i:= getMaxY downto 0 do begin
          for z:=1 to 2 do begin
            printbuffer :=constructLongInt(j,i);
            if inverse then printBuffer := not printbuffer;
            print(printbyte[3]);
            print(printbyte[2]);
            print(printbyte[1]);
          end
        end; print(10);
    end; {doline}

  begin {hardcopy}
    getviewsettings(viewport);  {save current viewport}
    setViewPort(0,0,getMaxX,getMaxY, false);
    print(27); print(Ord('3'));print(24);  {set line spacing}
    for j:=0 to ((getMaxX+1) SHR 3)-1 do doline(7);
    j :=((getMaxX+1) SHR 3);
    if (getMaxX+1) and 7 <>0 then
      doline((getMaxX+1) and 7);
    print(27); print(ord('2'));
    with viewport do
      setviewport(x1,y1,x2,y2, clip);   {restore viewport}
  end; {hardcopy}
end.  {scrcopy}

